<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegP002 extends Record {
    /**
     * @var array Lista de colunas esperadas para o bloco
     */   
    protected $templateColumns = [
        [
            'name' => "type_rule", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 1,
            'size' => 4
        ],
        [
            'name' => "cod1", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 5,
            'size' => 4
        ],
        [
            'name' => "chave1", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 9,
            'size' => 21
        ],
        [
            'name' => "cod2", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 30,
            'size' => 4
        ],
        [
            'name' => "chave2", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 34,
            'size' => 21
        ],
        [
            'name' => "cod3", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 55,
            'size' => 4
        ],
        [
            'name' => "chave3", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 59,
            'size' => 21
        ],
        [
            'name' => "cod4", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 80,
            'size' => 4
        ],
        [
            'name' => "chave4", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 84,
            'size' => 21
        ],
        [
            'name' => "filler", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 105,
            'size' => 11
        ],
    ];

    public function __construct($code_1 = null, $code_2 = null, $code_3 = null, $code_4 = null) {
        $this->createColumns();

        if($code_1) {
            $this->setValues($code_1, $code_2, $code_3, $code_4);
        }
    }

    /**
     * Define os valores do registro
     * Consultar os códigos válidos
     * @param string $code_1 Primeiro codigo 
     * @param string $code_2 Segundo codigo 
     * @param string $code_1 Terceiro codigo 
     * @param string $code_1 Quarto codigo 
     */
    private function setValues($code_1, $code_2, $code_3, $code_4) {
        $this->setColumnsValues([
            'type_rule' => "P002",
            'cod1' => $code_1,
            'chave1' => "",
            'cod2' => $code_2,
            'chave2' => "",
            'cod3' => $code_3,
            'chave3' => "",
            'cod4' => $code_4,
            'chave4' => "",
            'filler' => ""
        ]);
    }
}